#!/bin/sh 
########################################################################
# Copyright 2002 M Square Inc.
########################################################################
#
########################################################################
#
#  Shell script that starts a ParaChat server.  
#
########################################################################


# shut it down in case it is still running.
# 
echo "Shutting down server in case it is still running..."


pid=`cat ./pchatd.pid > /dev/null 2> /dev/null` 

if kill "$pid" > /dev/null 2> /dev/null 
then
   echo "Chat server has been shut down."
else
   echo " "
fi


# The Java program is required to run ParaChat Server - JDK 1.1.x or greater
# Download Java for free from http://www.javasoft.com/
# It may be necessary to use the full path, for example, on Linux,
# /usr/local/java/jdk1.3/bin/java
JAVA=java

####### YOU DO NOT NEED TO EDIT ANYTHING BELOW #########


# parachat Java classes
zipname=chat400.jar

# "Java version is, "
if $JAVA -version
then
   :
else
   echo "Java program was not found."
   echo "Consult your system admin to install Java."
   echo "Java is available at http://java.sun.com/"
   exit 2
fi

rightnow=`date +%Y_%m_%d-%H_%M_%S`

/bin/rm -f ./pchatd.pid

if [ -f server.log ]
then
    /bin/mv server.log server.log.$rightnow
fi

CLASSPATH="${zipname}"
JAVA_COMPILER=NONE
export CLASSPATH
export JAVA_COMPILER

echo " "
echo "Starting the ParaChat Server"

$JAVA -ms16m -mx119m ParaServer > server.log 2>&1 &
pid=$!

echo $pid > ./pchatd.pid

echo "Server started."
echo "Check \"server.log\" for server status."

