@echo off
REM ######################################################
REM #       Copyright 1996 - 2002 M Square, Inc.         #
REM #       ParaChat Windows NT Scripts                  #
REM #          www.ParaChat.com                          #
REM ######################################################

REM ###########################################################
REM #
REM #
REM #   Windows NT Script:
REM #
REM #   Upgrading ParaChat Server 3.0 to ParaChat 4.0
REM #
REM ###########################################################


SET noprompt=/Y
REM SET noprompt= 

for /f "tokens=*" %%I in ('CD') do set new_path=%%I

@echo %new_path% > upgradepwd.txt
@echo Current direcotry is, %new_path%


SET licensepath=config\paraserver.lic


if {%1}=={} (
  echo No parameters to upgrade program.
  echo ################################################
  echo #  Usage:
  echo #  upgrade.bat ParaChat300_server_absolute_path
  echo ################################################
  echo Make sure you put double quote around the path.
  echo For example: 
  echo upgrade.bat "C:\Program Files\ParaChat300"
  pause
  goto exitUpgrade
)

if {%2}=={} (
  echo off
) else (
  echo Too many parameters. Only one parameter is required.
  echo ################################################
  echo #  Usage:
  echo #  upgrade.bat ParaChat300_server_absolute_path
  echo ################################################
  echo Make sure you put double quote around the path.
  echo For example: 
  echo upgrade.bat "C:\Program Files\ParaChat300"
  pause
  goto exitUpgrade
)

echo The path you entered for the old ParaChat server is:
echo %*

REM remove double quote.
SET old_path=%1
SET old_path=%old_path:"=%

REM ###################################################
REM #
REM #    Checking Config of Version 3.0
REM ###################################################

echo ParaChat version 3.0 path is set to:
echo %old_path%
echo Checking version 3.0 license file.

SET old_lic=%old_path%\%licensepath%
echo Locate old license %old_lic%

if exist "%old_lic%" (
  echo Found version 3.0 license file. Continue.
) else (
  echo Cannot locate version 3.0 license file: 
  echo "%old_lic%"
  echo Please check your ParaChat server 3.0 path and try again.
  goto exitUpgrade
)


SET old_conf=%old_path%\config\pchatd.conf
echo Locate old config %old_conf%

if exist "%old_conf%" (
  echo Found version 3.0 config file. Continue.
) else (
  echo Cannot locate version 3.0 config file:
  echo "%old_conf%"
  echo Please check your ParaChat server 3.0 path and try again.
  goto exitUpgrade
)

REM ###################################################
REM #
REM #    Checking Config of Version 4.0
REM #    ParaChat 4.0 should have been installed.
REM #
REM ###################################################

echo ParaChat version 4.0 path is set to:
echo %new_path%
echo Checking version 4.0 license file.

SET new_lic=%new_path%\%licensepath%
echo Locate new license %new_lic%

if exist "%new_lic%" (
  echo Found version 4.0 license file. Continue.
) else (
  echo Cannot locate version 4.0 license file: 
  echo "%new_lic%"
  echo Please run this program under ParaChat4.0 directory.
  echo By default it is:
  echo "C:\Program Files\ParaChat\ParaChat400"
  echo Make sure also ParaChat 4.0 has been installed 
  echo successfully before running this program.
  goto exitUpgrade
)


SET new_conf=%new_path%\config\pchatd.conf
echo Locate new config %new_conf%

if exist "%new_conf%" (
  echo Found version 4.0 config file. Continue.
) else (
  echo Cannot locate version 4.0 config file:
  echo "%new_conf%"
  echo Please run this program under ParaChat4.0 directory.
  echo By default it is:
  echo "C:\Program Files\ParaChat\ParaChat400"
  echo Make sure also ParaChat 4.0 has been installed 
  echo successfully before running this program.
  goto exitUpgrade
)


REM #######################################################
REM #
REM # Copy data from v3.0 server
REM #
REM #######################################################


REM #############
REM # copy logs
REM #############

echo Copying logs directory...
if not exist logs (
  mkdir logs
)

if not exist "%old_path%\logs" (
  echo ###Warning: old logs directory does not exist
) else (
  echo on
  xcopy "%old_path%\logs\*" "%new_path%\logs\" /E /H /R /Q %noprompt%
  echo off
)



REM ###############
REM # copy radata
REM ###############

SET foldername=radata
echo Copying %foldername% directory...
if not exist %foldername% (
  mkdir %foldername%
)

if not exist "%old_path%\%foldername%" (
  echo ###Info: old %foldername% directory does not exist. OK to skip.
) else (
  echo on
  xcopy "%old_path%\%foldername%\*" "%new_path%\%foldername%\" /E /H /R /Q %noprompt%
  echo off
)



REM ###############
REM # copy rooms
REM ###############

SET foldername=rooms
echo Copying %foldername% directory...
if not exist %foldername% (
  mkdir %foldername%
)

if not exist "%old_path%\%foldername%" (
  echo ###Error: old %foldername% directory does not exist. 
  echo ###Error: no room data.
) else (
  echo on
  xcopy "%old_path%\%foldername%\*" "%new_path%\%foldername%\" /E /H /R /Q %noprompt%
  echo off
)



REM #################
REM # copy users
REM #################

SET foldername=users
echo Copying %foldername% directory...
if not exist %foldername% (
  mkdir %foldername%
)

if not exist "%old_path%\%foldername%" (
  echo ###Error: old %foldername% directory does not exist. 
  echo ###Error: no user data.
) else (
  echo on
  xcopy "%old_path%\%foldername%\*" "%new_path%\%foldername%\" /E /H /R /Q %noprompt%
  echo off
)



REM ######################
REM # copy ad scripts
REM ######################

echo "Copying ad scripts directory..."
SET foldername=httpd\pchat\classes\scripts

if not exist %foldername% (
  echo ###Error ParaChat400 does not have folder: %foldername%
)

if not exist "%old_path%\%foldername%" (
  echo ###Error: old %foldername% directory does not exist. 
  echo ###Error: no ad script data.
) else (
  echo on
  xcopy "%old_path%\%foldername%\*" "%new_path%\%foldername%\" /E /H /R /Q %noprompt%
  echo off
)



REM ###################
REM # copy ad images
REM ###################

echo "Copying ad scripts directory..."
SET foldername=httpd\pchat\classes\images

if not exist %foldername% (
  echo ###Error: ParaChat400 does not have folder: %foldername%
)

if not exist "%old_path%\%foldername%" (
  echo ###Warning: old %foldername% directory does not exist. 
  echo ###Warning: no ad image data.
) else (
  echo on
  xcopy "%old_path%\%foldername%\*" "%new_path%\%foldername%\" /E /H /R /Q %noprompt%
  echo off
)



REM ####################################################
REM # backup current 4.0 config file if it is necessary.
REM #####################################################

if not exist "%new_path%\config\pchatd.conf.40" (
  echo Backing up 4.0 config file...
  copy "%new_path%\config\pchatd.conf" "%new_path%\config\pchatd.conf.40"
) 



REM #################################################
REM #
REM # Process main server config pchatd.conf file.
REM # Copy config file of ParaChat 3.0 to directory of 4.0
REM #
REM ################################################

echo "Copying pchatd.conf ..."
SET filename=config\pchatd.conf

if not exist "%old_path%\%filename%" (
  echo ###Error: old ParaChat 3.0 does not have file: 
  echo ###Error: not found, "%old_path%\%filename%"
) else (
  echo on
  copy "%old_path%\%filename%" "%new_path%\config\"
  echo off
)


REM #######################
REM # Modify config file.
REM #######################

SET newconf=%new_path%\config\pchatd.conf
SET tempfile=%new_path%\config\pchatd.conf_temp
SET backupconf=%new_path%\config\pchatd.conf.30

@echo Adding new config parameters...

SET clientroot=paralynx.plugin.chatpanel.clientroot=%new_path%\httpd\pchat\classes
SET pchatdhome=pchatd.home=%new_path%

@echo on
echo %clientroot%>> "%newconf%"
echo %pchatdhome%>> "%newconf%"
@echo off

@echo ##############################################################
@echo   Upgrading has completed.
@echo   Check the messages above and make sure there was no error.
@echo   Please also place your new 4.0 license under "config" folder.
@echo ###############################################################

goto exitUpgrade

################
#  Done
################

REM skip this section
echo off
copy "%newconf%" "%backupconf%"
for /f "tokens=*" %%I in ('TYPE "config\pchatd.conf"') do (
  rem set single_line=%%I
  rem @echo %%I
  rem @echo %single_line%
  rem set singleline=%singleline:paralynx.plugin.chatpanel.clientroot=paralynx.plugin.chatpanel.clientroot_old30%
  rem set singleline=%singleline:=pchatd.home_old30%
  rem echo %singleline%
  rem @echo %singleline%>> "%tempfile%"
)
copy "%tempfile%" "%newconf%"


:exitUpgrade
pause
